      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       class-id MicroFocus.COBOL.Examples.Support.DateJvm inherits type AbstractDate public.
      
       01 dtRepresentation        type Calendar. 

       method-id New (lnkYear as binary-long, lnkMonth as binary-long, lnkDay as binary-long).
           set dtRepresentation to type Calendar::getInstance()
           invoke dtRepresentation::setLenient(false)
           invoke dtRepresentation::set(lnkYear lnkMonth - 1 lnkDay)
           invoke dtRepresentation::getTime() *> Trigger validation of date
       
       end method. 
       
       method-id New() public.
           set dtRepresentation to type Calendar::getInstance()
           invoke dtRepresentation::setLenient(false)
       end method. 
       
       method-id New (dt as type IDate).
           invoke self::New(dt::Year dt::Month dt::Day)
       end method. 
       
       method-id New(dt as type Calendar) public.
           move dt to dtRepresentation 
       end method. 
       
       property-id Year binary-long public override. 
       getter.
           set property-value to dtRepresentation::get(type Calendar::YEAR)
       end property. 
       
       property-id Month binary-long public override. 
       getter. 
           set property-value to dtRepresentation::get(type Calendar::MONTH) + 1
       end property. 
       
       property-id Day binary-long public override.  
       getter. 
           set property-value to dtRepresentation::get(type Calendar::DAY_OF_MONTH)
       end property. 
       
s
       method-id Subtract (dt as type IDate ) returning return-item as binary-long override.
      *>   Note - this method of calculating difference in days can fail across leap years. 
      *>   Our examples use standard Java SE classes to make them simpler to build and work with
      *>   but the free org.joda.time library provides much better facilities for working with dates
      *>   than the standard java.util.Calendar, Date and DateFormat classes.
           declare dn as type DateJvm = new DateJvm(dt)
           declare endDays as binary-double = dtRepresentation::getTimeInMillis() / 1000 / 3600 / 24 
           declare startDays as binary-double = dn::dtRepresentation::getTimeInMillis() / 1000 / 3600 / 24
           
           set return-item to endDays - startDays 
       end method.

       method-id Add (days as binary-long) returning result as type IDate override.
         
           declare resultDt as type Calendar = dtRepresentation::clone() as type Calendar
           invoke resultDt::add(type Calendar::DATE days)
           set result to new DateJvm(resultDt)
          
        end method.
      
       method-id GetDayOfWeek returning result as string override.
           set result to dtRepresentation::get(type Calendar::DAY_OF_WEEK)
       end method.

       method-id GetFormattedDate returning result as string override.
           declare df = type DateFormat::getDateInstance(type DateFormat::MEDIUM) 
           invoke df::setCalendar(dtRepresentation)
           set result to df::format(dtRepresentation::getTime())
       end method. 
       
       method-id toString() returning result as string override. 
           set result to GetFormattedDate()
       end method.
       
       method-id hashCode() returning result as binary-long override.
           set result to super::Hash()
       end method.
       
       method-id equals(o as object) returning result as condition-value  override.
           set result to CompareTo(o) = 0
       end method. 
       
       end class.
