      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       program-id. PersonFile.
           file-control.
           select PersonFile assign to dynamic fullPathName
               file status is file-status
               organization is indexed 
               access mode is dynamic
               record key is filerec-email
               .
      
       file section.
       fd personFile.
       copy "PersonRecord.cpy" replacing ==(prefix)== by ==filerec==. 
       working-storage section. 
       01 file-status.
        03 file-status-1   pic x.
        03 file-status-2   pic x.
        03 extended-status redefines file-status-2 pic 99 comp-x.
       linkage section. 
       01 lnk-status      pic xx. 
       01 lnk-filename    pic x(260). 
       copy "fileoperations.cpy" replacing ==(prefix)== by ==lnk==. 
       copy "PersonRecord.cpy" replacing ==(prefix)== by ==lnk==.
      
       procedure division using by value lnk-function 
                            by reference lnk-person lnk-status.
           evaluate lnk-function
               when read-record
                   perform do-read-record    
               when add-record
                   perform do-add-record
               when delete-record
                   perform do-delete-record
               when next-record
                   perform do-next-record
               when update-record
                   perform do-update-record
           end-evaluate
           goback
           .
           
       do-read-record section. 
           open input PersonFile 
           move file-status to lnk-status
           if file-status = "00" then
               if lnk-email <> low-values and lnk-email <> spaces
                       move lnk-email to filerec-email
                       read PersonFile
                else
      *>---------------No key specified - return unsuccessful read
                       move "23" to lnk-status
               end-if
               if file-status = 0 
                   move filerec-person to lnk-person
               end-if
               move file-status to lnk-status
               end-if     
           close PersonFile
       .
       do-add-record section. 
           open i-o PersonFile
           evaluate file-status
               when "05"
      *>-------File not created yet
               when "00"
                   continue
               when other
                   move file-status to lnk-status
                   exit section
           end-evaluate

           move lnk-email  to filerec-email
           read PersonFile
           if file-status = "00"
      * Record already exists - so error
               move "99" to lnk-status
           else
               move lnk-person to filerec-person
               write filerec-person
       
           move file-status to lnk-status
           close PersonFile
           .
       
       do-delete-record section.
           open i-o PersonFile
           if file-status <> "00"
               move file-status to lnk-status
               exit section
           end-if

           evaluate true
               when lnk-email <> spaces and lnk-email <> low-values
                   move lnk-email to filerec-email
                   read PersonFile
                   delete PersonFile record
              when other
      *>------------No key specified - return unsuccessful read
                   move "23" to file-status

           end-evaluate

           move file-status to lnk-status
           close PersonFile
           .
       
       do-next-record section. 
           open input PersonFile
           if file-status <> "00"
               move file-status to lnk-status
               exit section
           end-if

           move lnk-email to filerec-email
           start PersonFile key > filerec-email
           read PersonFile next

           move file-status to lnk-status
           if  file-status = "00"
              move filerec-person to lnk-person
           end-if
           close PersonFile
           .
       do-update-record section.
            open i-o PersonFile
           evaluate file-status
               when "05"
      *>-------File not created yet
               when "00"
                   continue
               when other
                   move file-status to lnk-status
                   exit section
           end-evaluate
           move lnk-email  to filerec-email
           read PersonFile
           if file-status <> "00"
      * Record does not exist  - so error
               move "99" to lnk-status
           else
               move lnk-person to filerec-person
               rewrite filerec-person
               move file-status to lnk-status
           end-if
           close PersonFile
          .
          
       copy "Filename.cpy".    
           
       end program PersonFile.