      **************************************************************************
      *
      * Copyright (C) Micro Focus 2015-2016.
      * All rights reserved.
      *
      * This sample code is supplied for demonstration purposes only
      * on an "as is" basis and is for use at your own risk.
      *
      **************************************************************************
       program-id RentalPropertyFile.
           file-control.
           select property-file assign to dynamic fullPathname
               file status is file-status
               organization is indexed 
               access mode is dynamic
               record key is filerec-address-key
               .

       file section.
       fd property-file.
       copy "PropertyRecord.cpy" replacing ==(prefix)== by ==filerec==. 
           
       working-storage section. 
       01 file-status              pic xx.
       
       linkage section. 
       01 lnk-status      pic xx. 
       01 lnk-filename    pic x(260). 

       copy "fileoperations.cpy" replacing ==(prefix)== by ==lnk==. 
       copy "PropertyRecord.cpy" replacing ==(prefix)== by ==lnk==.
       
       procedure division using by value lnk-function 
                            by reference lnk-property lnk-status.
           evaluate lnk-function
               when read-record
                   perform do-read-record    
               when add-record
                   perform do-add-record
               when delete-record
                   perform do-delete-record
               when next-record
                   perform do-next-record
               when update-record
                   perform do-update-record
           end-evaluate
           goback
           .
           
       do-read-record section. 
           open input property-file 
           move file-status to lnk-status
           if file-status = "00" then
               evaluate true
                   when lnk-address-key <> low-values and lnk-address-key <> spaces
                       move lnk-address-key to filerec-address-key
                       read property-file key is filerec-address-key
                   when other
      *>---------------No key specified - return unsuccessful read
                       move statusNotFound to lnk-status
               end-evaluate
               if file-status = "00" 
                   move filerec-Property to lnk-property
               end-if
               move file-status to lnk-status
           end-if     
           close property-file
       .
       do-add-record section. 
           open i-o property-file
           evaluate file-status
               when "05"
      *>-------File not created yet
               when "00"
                   continue

               when other
                   move file-status to lnk-status
                   exit section
           end-evaluate

           move lnk-address-key to filerec-address-key
           read property-file
           if file-status = "00"
      * Record already exists - so error
               move "99" to lnk-status
           else
               move lnk-Property to filerec-Property
               write filerec-property
           end-if
       
           move file-status to lnk-status
           close property-file
           move lnk-property to filerec-property
           close property-file
           .
       
       do-delete-record section.
           open i-o property-file
           if file-status <> "00"
               move file-status to lnk-status
               exit section
           end-if

           evaluate true
               when lnk-address-key <> spaces and lnk-address-key <> low-values
                   move lnk-address-key to filerec-address-key
                   read property-file
                   delete property-file record
              when other
      *>------------No key specified - return unsuccessful read
                   move "23" to file-status
           end-evaluate

           move file-status to lnk-status
           close property-file
           .
       
       do-next-record section. 
           open input property-file
           if file-status <> "00"
               move file-status to lnk-status
               exit section
           end-if

           move lnk-address-key to filerec-address-key
           start property-file key > filerec-address-key
           read property-file next

           move file-status to lnk-status
           if  file-status = "00"
              move filerec-property to lnk-property
           end-if
           close property-file
           .
       do-update-record section.
            open i-o property-file
           evaluate file-status
               when "05"
      *>-------File not created yet
               when "00"
                   continue
               when other
                   move file-status to lnk-status
                   exit section
           end-evaluate
           move lnk-address-key  to filerec-address-key
           read property-file
           if file-status <> "00"
      * Record does not exist  - so error
               move "99" to lnk-status
           else
               move lnk-property to filerec-property
               rewrite filerec-property
           end-if
           move file-status to lnk-status
           close property-file
           .
       copy "filename.cpy".     
           
           
       end program.
