////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.examples.javawebleases.application;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.ws.rs.core.Application;

import MicroFocus.COBOL.Store.AgencyStore;

public class WebLeases extends Application
{
    public static final String APPLICATION_ROOT = "JavaWebLeases"; 
    
    public static final String REST_SERVICE_PATH = "service"; 
    
    public static final String CONFIG_FILE = "webleases.properties"; 
    
    public Set<Class<?>> getClasses()
    {
        Properties properties = new Properties(); 
        
        // Read resources 
        Set<Class<?>> resources = new HashSet<Class<?>>(); 
        Map<String,String> propertyDictionary = new HashMap<String,String>();
        ClassLoader cl = getClass().getClassLoader();
        try (InputStream propertiesStream =  cl.getResourceAsStream(CONFIG_FILE))
        {
            properties.load(propertiesStream);
            
            for (String key : properties.stringPropertyNames())
            {
                String filename = properties.getProperty(key); 
                propertyDictionary.put(key, filename);
            }
            AgencyStore.SetFilenames(propertyDictionary);
        }
        catch (IOException e)
        {
            // Rethrow exception, application will be unable to run.
            throw new RuntimeException(e);
        }
        return resources; 
    }
    
    
}
