////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.examples.javawebleases.controllers;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.UriInfo;
import MicroFocus.COBOL.Examples.LeaseDto;
import MicroFocus.COBOL.Examples.Lettings.Lease;

@Path("/leases")
public class LeasesController extends AbstractController 
{
    @Context
    UriInfo uri ; 
    
    @GET
    @Produces(MediaType.APPLICATION_JSON)
    public JsonArrayHolder<List<LeaseDto>> getLeases()
    {
        List<LeaseDto> serializableLeases = new ArrayList<LeaseDto>();
        for (Lease l : getStore().GetLeases())
        {
            serializableLeases.add(new LeaseDto(l));
        }
        return new JsonArrayHolder<List<LeaseDto>> (serializableLeases); 
    }
    
    @GET
    @Path("{id}")
    @Produces(MediaType.APPLICATION_JSON)
    public LeaseDto getLease(@PathParam("id") String id) throws UnsupportedEncodingException
    {
        Lease l = getStore().FindLease(id);
        LeaseDto dto = l == null ? null : new LeaseDto(l); 
        return dto; 
    }
    
    @POST
    @Path("{id}")
    @Produces(MediaType.APPLICATION_JSON)
    public LeaseDto getLandlordFromPost(@PathParam("id") String id) throws UnsupportedEncodingException
    {
        return getLease(id); 
    }
}
