////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////
package com.microfocus.examples.javawebleases.controllers;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.UriInfo;

import MicroFocus.COBOL.Examples.RentalPropertyDto;
import MicroFocus.COBOL.Examples.Support.Address;
import MicroFocus.COBOL.Examples.Lettings.RentalProperty;

@Path("/properties")
public class PropertiesController extends AbstractController 
{
    private final String KEY_SEPARATOR = "~"; 
    
    
    @Context
    UriInfo uri ; 
    
    @GET
    @Produces(MediaType.APPLICATION_JSON)
    public JsonArrayHolder<List<RentalPropertyDto>> getProperties()
    {
        List<RentalPropertyDto> serializableLeases = new ArrayList<RentalPropertyDto>();
        for (RentalProperty r : getStore().GetRentalProperties())
        {
            serializableLeases.add(new RentalPropertyDto(r));
        }
        return new JsonArrayHolder<List<RentalPropertyDto>> (serializableLeases); 
    }
    
    @GET
    @Path("{id}")
    @Produces(MediaType.APPLICATION_JSON)
    public RentalPropertyDto getProperty(@PathParam("id") String id) throws UnsupportedEncodingException
    {
        String[] parts = id.split(KEY_SEPARATOR);
        if (parts.length != 2)
        {
            
        }
        
        Address key = new Address(parts[0], "", "", parts[1]);
        
        RentalProperty r = getStore().FindProperty(key);
        RentalPropertyDto dto = r == null ? null : new RentalPropertyDto(r); 
        return dto; 
    }
    
    @POST
    @Path("{id}")
    @Produces(MediaType.APPLICATION_JSON)
    public RentalPropertyDto getPropertyFromPost(@PathParam("id") String id) throws UnsupportedEncodingException
    {
        return getProperty(id); 
    }
}
