﻿////////////////////////////////////////////////////////////////////////////
///
/// Copyright(C) Micro Focus 2015-2016.
/// All rights reserved.
///
/// This sample code is supplied for demonstration purposes only
/// on an "as is" basis and is for use at your own risk.
///
////////////////////////////////////////////////////////////////////////////using MicroFocus.AgencyText;
using MicroFocus.COBOL.Examples;
using MicroFocus.COBOL.Examples.Lettings;
using MicroFocus.COBOL.Examples.Support;
using MicroFocus.COBOL.Store;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace WebLeases.Controllers
{
    public class LeasesController : Controller
    {
        public AgencyStore Store
        {
            get
            {
                return AgencyStore.GetStore();
            }
        }

        // GET: Tenants
        [HttpGet]
        public ActionResult Index(String id)
        {
            if (id != null)
            {
                var lease = Store.FindLease(id); 
                if (lease!= null)
                {
                    return Json(new LeaseDto(lease), JsonRequestBehavior.AllowGet);
                }
                else
                {
                    Response.StatusCode = 404;
                    return Json(null, JsonRequestBehavior.AllowGet);
                }
            }
            else
            {
                var leases = new List<LeaseDto>(); 
                foreach  (Lease lease in Store.GetLeases())
                {
                    leases.Add(new LeaseDto(lease));
                }

                return Json(new { list = leases }, JsonRequestBehavior.AllowGet);
            }
        }
    }
}
